Index: src/tesselationhelpers.cpp
===================================================================
--- src/tesselationhelpers.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/tesselationhelpers.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -14,4 +14,5 @@
 #include "tesselationhelpers.hpp"
 #include "vector.hpp"
+#include "vector_ops.hpp"
 #include "verbose.hpp"
 
@@ -27,5 +28,5 @@
   int signum;
   gsl_permutation *p = gsl_permutation_alloc(A->size1);
-  gsl_matrix *tmpA;
+  gsl_matrix *tmpA=0;
 
   if (inPlace)
@@ -53,40 +54,40 @@
 
   for(int i=0;i<3;i++) {
-    gsl_matrix_set(A, i, 0, a.x[i]);
-    gsl_matrix_set(A, i, 1, b.x[i]);
-    gsl_matrix_set(A, i, 2, c.x[i]);
+    gsl_matrix_set(A, i, 0, a[i]);
+    gsl_matrix_set(A, i, 1, b[i]);
+    gsl_matrix_set(A, i, 2, c[i]);
   }
   m11 = DetGet(A, 1);
 
   for(int i=0;i<3;i++) {
-    gsl_matrix_set(A, i, 0, a.x[i]*a.x[i] + b.x[i]*b.x[i] + c.x[i]*c.x[i]);
-    gsl_matrix_set(A, i, 1, b.x[i]);
-    gsl_matrix_set(A, i, 2, c.x[i]);
+    gsl_matrix_set(A, i, 0, a[i]*a[i] + b[i]*b[i] + c[i]*c[i]);
+    gsl_matrix_set(A, i, 1, b[i]);
+    gsl_matrix_set(A, i, 2, c[i]);
   }
   m12 = DetGet(A, 1);
 
   for(int i=0;i<3;i++) {
-    gsl_matrix_set(A, i, 0, a.x[i]*a.x[i] + b.x[i]*b.x[i] + c.x[i]*c.x[i]);
-    gsl_matrix_set(A, i, 1, a.x[i]);
-    gsl_matrix_set(A, i, 2, c.x[i]);
+    gsl_matrix_set(A, i, 0, a[i]*a[i] + b[i]*b[i] + c[i]*c[i]);
+    gsl_matrix_set(A, i, 1, a[i]);
+    gsl_matrix_set(A, i, 2, c[i]);
   }
   m13 = DetGet(A, 1);
 
   for(int i=0;i<3;i++) {
-    gsl_matrix_set(A, i, 0, a.x[i]*a.x[i] + b.x[i]*b.x[i] + c.x[i]*c.x[i]);
-    gsl_matrix_set(A, i, 1, a.x[i]);
-    gsl_matrix_set(A, i, 2, b.x[i]);
+    gsl_matrix_set(A, i, 0, a[i]*a[i] + b[i]*b[i] + c[i]*c[i]);
+    gsl_matrix_set(A, i, 1, a[i]);
+    gsl_matrix_set(A, i, 2, b[i]);
   }
   m14 = DetGet(A, 1);
 
   if (fabs(m11) < MYEPSILON)
-    eLog() << Verbose(1) << "three points are colinear." << endl;
-
-  center->x[0] =  0.5 * m12/ m11;
-  center->x[1] = -0.5 * m13/ m11;
-  center->x[2] =  0.5 * m14/ m11;
-
-  if (fabs(a.Distance(center) - RADIUS) > MYEPSILON)
-    eLog() << Verbose(1) << "The given center is further way by " << fabs(a.Distance(center) - RADIUS) << " from a than RADIUS." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "three points are colinear." << endl);
+
+  center->at(0) =  0.5 * m12/ m11;
+  center->at(1) = -0.5 * m13/ m11;
+  center->at(2) =  0.5 * m14/ m11;
+
+  if (fabs(a.distance(*center) - RADIUS) > MYEPSILON)
+    DoeLog(1) && (eLog()<< Verbose(1) << "The given center is further way by " << fabs(a.distance(*center) - RADIUS) << " from a than RADIUS." << endl);
 
   gsl_matrix_free(A);
@@ -120,37 +121,32 @@
   Vector OtherCenter;
   Center->Zero();
-  helper.CopyVector(&a);
-  helper.Scale(sin(2.*alpha));
-  Center->AddVector(&helper);
-  helper.CopyVector(&b);
-  helper.Scale(sin(2.*beta));
-  Center->AddVector(&helper);
-  helper.CopyVector(&c);
-  helper.Scale(sin(2.*gamma));
-  Center->AddVector(&helper);
+  helper = sin(2.*alpha) * a;
+  (*Center) += helper;
+  helper = sin(2.*beta) * b;
+  (*Center) += helper;
+  helper = sin(2.*gamma) * c;
+  (*Center) += helper;
   //*Center = a * sin(2.*alpha) + b * sin(2.*beta) + c * sin(2.*gamma) ;
   Center->Scale(1./(sin(2.*alpha) + sin(2.*beta) + sin(2.*gamma)));
-  NewUmkreismittelpunkt->CopyVector(Center);
-  Log() << Verbose(1) << "Center of new circumference is " << *NewUmkreismittelpunkt << ".\n";
+  (*NewUmkreismittelpunkt) = (*Center);
+  DoLog(1) && (Log() << Verbose(1) << "Center of new circumference is " << *NewUmkreismittelpunkt << ".\n");
   // Here we calculated center of circumscribing circle, using barycentric coordinates
-  Log() << Verbose(1) << "Center of circumference is " << *Center << " in direction " << *Direction << ".\n";
-
-  TempNormal.CopyVector(&a);
-  TempNormal.SubtractVector(&b);
-  helper.CopyVector(&a);
-  helper.SubtractVector(&c);
-  TempNormal.VectorProduct(&helper);
+  DoLog(1) && (Log() << Verbose(1) << "Center of circumference is " << *Center << " in direction " << *Direction << ".\n");
+
+  TempNormal = a - b;
+  helper = a - c;
+  TempNormal.VectorProduct(helper);
   if (fabs(HalfplaneIndicator) < MYEPSILON)
     {
-      if ((TempNormal.ScalarProduct(AlternativeDirection) <0 && AlternativeIndicator >0) || (TempNormal.ScalarProduct(AlternativeDirection) >0 && AlternativeIndicator <0))
+      if ((TempNormal.ScalarProduct(*AlternativeDirection) <0 && AlternativeIndicator >0) || (TempNormal.ScalarProduct(*AlternativeDirection) >0 && AlternativeIndicator <0))
         {
-          TempNormal.Scale(-1);
+          TempNormal *= -1;
         }
     }
   else
     {
-      if (((TempNormal.ScalarProduct(Direction)<0) && (HalfplaneIndicator >0)) || ((TempNormal.ScalarProduct(Direction)>0) && (HalfplaneIndicator<0)))
+      if (((TempNormal.ScalarProduct(*Direction)<0) && (HalfplaneIndicator >0)) || ((TempNormal.ScalarProduct(*Direction)>0) && (HalfplaneIndicator<0)))
         {
-          TempNormal.Scale(-1);
+          TempNormal *= -1;
         }
     }
@@ -158,12 +154,11 @@
   TempNormal.Normalize();
   Restradius = sqrt(RADIUS*RADIUS - Umkreisradius*Umkreisradius);
-  Log() << Verbose(1) << "Height of center of circumference to center of sphere is " << Restradius << ".\n";
+  DoLog(1) && (Log() << Verbose(1) << "Height of center of circumference to center of sphere is " << Restradius << ".\n");
   TempNormal.Scale(Restradius);
-  Log() << Verbose(1) << "Shift vector to sphere of circumference is " << TempNormal << ".\n";
-
-  Center->AddVector(&TempNormal);
-  Log() << Verbose(1) << "Center of sphere of circumference is " << *Center << ".\n";
+  DoLog(1) && (Log() << Verbose(1) << "Shift vector to sphere of circumference is " << TempNormal << ".\n");
+  (*Center) += TempNormal;
+  DoLog(1) && (Log() << Verbose(1) << "Center of sphere of circumference is " << *Center << ".\n");
   GetSphere(&OtherCenter, a, b, c, RADIUS);
-  Log() << Verbose(1) << "OtherCenter of sphere of circumference is " << OtherCenter << ".\n";
+  DoLog(1) && (Log() << Verbose(1) << "OtherCenter of sphere of circumference is " << OtherCenter << ".\n");
 };
 
@@ -180,29 +175,22 @@
   Vector helper;
   double alpha, beta, gamma;
-  Vector SideA, SideB, SideC;
-  SideA.CopyVector(b);
-  SideA.SubtractVector(&c);
-  SideB.CopyVector(c);
-  SideB.SubtractVector(&a);
-  SideC.CopyVector(a);
-  SideC.SubtractVector(&b);
-  alpha = M_PI - SideB.Angle(&SideC);
-  beta = M_PI - SideC.Angle(&SideA);
-  gamma = M_PI - SideA.Angle(&SideB);
+  Vector SideA = b - c;
+  Vector SideB = c - a;
+  Vector SideC = a - b;
+  alpha = M_PI - SideB.Angle(SideC);
+  beta = M_PI - SideC.Angle(SideA);
+  gamma = M_PI - SideA.Angle(SideB);
   //Log() << Verbose(1) << "INFO: alpha = " << alpha/M_PI*180. << ", beta = " << beta/M_PI*180. << ", gamma = " << gamma/M_PI*180. << "." << endl;
   if (fabs(M_PI - alpha - beta - gamma) > HULLEPSILON) {
-    eLog() << Verbose(1) << "GetCenterofCircumcircle: Sum of angles " << (alpha+beta+gamma)/M_PI*180. << " > 180 degrees by " << fabs(M_PI - alpha - beta - gamma)/M_PI*180. << "!" << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "GetCenterofCircumcircle: Sum of angles " << (alpha+beta+gamma)/M_PI*180. << " > 180 degrees by " << fabs(M_PI - alpha - beta - gamma)/M_PI*180. << "!" << endl);
   }
 
   Center->Zero();
-  helper.CopyVector(a);
-  helper.Scale(sin(2.*alpha));
-  Center->AddVector(&helper);
-  helper.CopyVector(b);
-  helper.Scale(sin(2.*beta));
-  Center->AddVector(&helper);
-  helper.CopyVector(c);
-  helper.Scale(sin(2.*gamma));
-  Center->AddVector(&helper);
+  helper = sin(2.*alpha) * a;
+  (*Center) += helper;
+  helper = sin(2.*beta) * b;
+  (*Center) += helper;
+  helper = sin(2.*gamma) * c;
+  (*Center) += helper;
   Center->Scale(1./(sin(2.*alpha) + sin(2.*beta) + sin(2.*gamma)));
 };
@@ -226,34 +214,30 @@
   Vector helper;
   double radius, alpha;
-  Vector RelativeOldSphereCenter;
-  Vector RelativeNewSphereCenter;
-
-  RelativeOldSphereCenter.CopyVector(&OldSphereCenter);
-  RelativeOldSphereCenter.SubtractVector(&CircleCenter);
-  RelativeNewSphereCenter.CopyVector(&NewSphereCenter);
-  RelativeNewSphereCenter.SubtractVector(&CircleCenter);
-  helper.CopyVector(&RelativeNewSphereCenter);
+
+  Vector RelativeOldSphereCenter = OldSphereCenter - CircleCenter;
+  Vector RelativeNewSphereCenter = NewSphereCenter - CircleCenter;
+  helper = RelativeNewSphereCenter;
   // test whether new center is on the parameter circle's plane
-  if (fabs(helper.ScalarProduct(&CirclePlaneNormal)) > HULLEPSILON) {
-    eLog() << Verbose(1) << "Something's very wrong here: NewSphereCenter is not on the band's plane as desired by " <<fabs(helper.ScalarProduct(&CirclePlaneNormal))  << "!" << endl;
-    helper.ProjectOntoPlane(&CirclePlaneNormal);
+  if (fabs(helper.ScalarProduct(CirclePlaneNormal)) > HULLEPSILON) {
+    DoeLog(1) && (eLog()<< Verbose(1) << "Something's very wrong here: NewSphereCenter is not on the band's plane as desired by " <<fabs(helper.ScalarProduct(CirclePlaneNormal))  << "!" << endl);
+    helper.ProjectOntoPlane(CirclePlaneNormal);
   }
   radius = helper.NormSquared();
   // test whether the new center vector has length of CircleRadius
   if (fabs(radius - CircleRadius) > HULLEPSILON)
-    eLog() << Verbose(1) << "The projected center of the new sphere has radius " << radius << " instead of " << CircleRadius << "." << endl;
-  alpha = helper.Angle(&RelativeOldSphereCenter);
+    DoeLog(1) && (eLog()<< Verbose(1) << "The projected center of the new sphere has radius " << radius << " instead of " << CircleRadius << "." << endl);
+  alpha = helper.Angle(RelativeOldSphereCenter);
   // make the angle unique by checking the halfplanes/search direction
-  if (helper.ScalarProduct(&SearchDirection) < -HULLEPSILON)  // acos is not unique on [0, 2.*M_PI), hence extra check to decide between two half intervals
+  if (helper.ScalarProduct(SearchDirection) < -HULLEPSILON)  // acos is not unique on [0, 2.*M_PI), hence extra check to decide between two half intervals
     alpha = 2.*M_PI - alpha;
-  Log() << Verbose(1) << "INFO: RelativeNewSphereCenter is " << helper << ", RelativeOldSphereCenter is " << RelativeOldSphereCenter << " and resulting angle is " << alpha << "." << endl;
-  radius = helper.Distance(&RelativeOldSphereCenter);
-  helper.ProjectOntoPlane(&NormalVector);
+  DoLog(1) && (Log() << Verbose(1) << "INFO: RelativeNewSphereCenter is " << helper << ", RelativeOldSphereCenter is " << RelativeOldSphereCenter << " and resulting angle is " << alpha << "." << endl);
+  radius = helper.distance(RelativeOldSphereCenter);
+  helper.ProjectOntoPlane(NormalVector);
   // check whether new center is somewhat away or at least right over the current baseline to prevent intersecting triangles
   if ((radius > HULLEPSILON) || (helper.Norm() < HULLEPSILON)) {
-    Log() << Verbose(1) << "INFO: Distance between old and new center is " << radius << " and between new center and baseline center is " << helper.Norm() << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Distance between old and new center is " << radius << " and between new center and baseline center is " << helper.Norm() << "." << endl);
     return alpha;
   } else {
-    Log() << Verbose(1) << "INFO: NewSphereCenter " << RelativeNewSphereCenter << " is too close to RelativeOldSphereCenter" << RelativeOldSphereCenter << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "INFO: NewSphereCenter " << RelativeNewSphereCenter << " is too close to RelativeOldSphereCenter" << RelativeOldSphereCenter << "." << endl);
     return 2.*M_PI;
   }
@@ -279,21 +263,16 @@
   struct Intersection *I = (struct Intersection *)params;
   Vector intersection;
-  Vector SideA,SideB,HeightA, HeightB;
   for (int i=0;i<NDIM;i++)
-    intersection.x[i] = gsl_vector_get(x, i);
-
-  SideA.CopyVector(&(I->x1));
-  SideA.SubtractVector(&I->x2);
-  HeightA.CopyVector(&intersection);
-  HeightA.SubtractVector(&I->x1);
-  HeightA.ProjectOntoPlane(&SideA);
-
-  SideB.CopyVector(&I->x3);
-  SideB.SubtractVector(&I->x4);
-  HeightB.CopyVector(&intersection);
-  HeightB.SubtractVector(&I->x3);
-  HeightB.ProjectOntoPlane(&SideB);
-
-  retval = HeightA.ScalarProduct(&HeightA) + HeightB.ScalarProduct(&HeightB);
+    intersection[i] = gsl_vector_get(x, i);
+
+  Vector SideA = I->x1 -I->x2 ;
+  Vector HeightA = intersection - I->x1;
+  HeightA.ProjectOntoPlane(SideA);
+
+  Vector SideB = I->x3 - I->x4;
+  Vector HeightB = intersection - I->x3;
+  HeightB.ProjectOntoPlane(SideB);
+
+  retval = HeightA.ScalarProduct(HeightA) + HeightB.ScalarProduct(HeightB);
   //Log() << Verbose(1) << "MinIntersectDistance called, result: " << retval << endl;
 
@@ -320,8 +299,8 @@
 
   struct Intersection par;
-    par.x1.CopyVector(&point1);
-    par.x2.CopyVector(&point2);
-    par.x3.CopyVector(&point3);
-    par.x4.CopyVector(&point4);
+    par.x1 = point1;
+    par.x2 = point2;
+    par.x3 = point3;
+    par.x4 = point4;
 
     const gsl_multimin_fminimizer_type *T = gsl_multimin_fminimizer_nmsimplex;
@@ -336,7 +315,7 @@
     /* Starting point */
     x = gsl_vector_alloc(NDIM);
-    gsl_vector_set(x, 0, point1.x[0]);
-    gsl_vector_set(x, 1, point1.x[1]);
-    gsl_vector_set(x, 2, point1.x[2]);
+    gsl_vector_set(x, 0, point1[0]);
+    gsl_vector_set(x, 1, point1[1]);
+    gsl_vector_set(x, 2, point1[2]);
 
     /* Set initial step sizes to 1 */
@@ -364,28 +343,24 @@
 
         if (status == GSL_SUCCESS) {
-          Log() << Verbose(1) << "converged to minimum" <<  endl;
+          DoLog(1) && (Log() << Verbose(1) << "converged to minimum" <<  endl);
         }
     } while (status == GSL_CONTINUE && iter < 100);
 
     // check whether intersection is in between or not
-  Vector intersection, SideA, SideB, HeightA, HeightB;
+  Vector intersection;
   double t1, t2;
   for (int i = 0; i < NDIM; i++) {
-    intersection.x[i] = gsl_vector_get(s->x, i);
-  }
-
-  SideA.CopyVector(&par.x2);
-  SideA.SubtractVector(&par.x1);
-  HeightA.CopyVector(&intersection);
-  HeightA.SubtractVector(&par.x1);
-
-  t1 = HeightA.ScalarProduct(&SideA)/SideA.ScalarProduct(&SideA);
-
-  SideB.CopyVector(&par.x4);
-  SideB.SubtractVector(&par.x3);
-  HeightB.CopyVector(&intersection);
-  HeightB.SubtractVector(&par.x3);
-
-  t2 = HeightB.ScalarProduct(&SideB)/SideB.ScalarProduct(&SideB);
+    intersection[i] = gsl_vector_get(s->x, i);
+  }
+
+  Vector SideA = par.x2 - par.x1;
+  Vector HeightA = intersection - par.x1;
+
+  t1 = HeightA.ScalarProduct(SideA)/SideA.ScalarProduct(SideA);
+
+  Vector SideB = par.x4 - par.x3;
+  Vector HeightB = intersection - par.x3;
+
+  t2 = HeightB.ScalarProduct(SideB)/SideB.ScalarProduct(SideB);
 
   Log() << Verbose(1) << "Intersection " << intersection << " is at "
@@ -394,8 +369,8 @@
 
   if (((t1 >= 0) && (t1 <= 1)) && ((t2 >= 0) && (t2 <= 1))) {
-    Log() << Verbose(1) << "true intersection." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "true intersection." << endl);
     result = true;
   } else {
-    Log() << Verbose(1) << "intersection out of region of interest." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "intersection out of region of interest." << endl);
     result = false;
   }
@@ -427,10 +402,10 @@
   if (point.IsZero())
     return M_PI;
-  double phi = point.Angle(&reference);
-  if (OrthogonalVector.ScalarProduct(&point) > 0) {
+  double phi = point.Angle(reference);
+  if (OrthogonalVector.ScalarProduct(point) > 0) {
     phi = 2.*M_PI - phi;
   }
 
-  Log() << Verbose(1) << "INFO: " << point << " has angle " << phi << " with respect to reference " << reference << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: " << point << " has angle " << phi << " with respect to reference " << reference << "." << endl);
 
   return phi;
@@ -451,12 +426,12 @@
   double volume;
 
-  TetraederVector[0].CopyVector(a);
-  TetraederVector[1].CopyVector(b);
-  TetraederVector[2].CopyVector(c);
+  TetraederVector[0] = a;
+  TetraederVector[1] = b;
+  TetraederVector[2] = c;
   for (int j=0;j<3;j++)
-    TetraederVector[j].SubtractVector(&d);
-  Point.CopyVector(&TetraederVector[0]);
-  Point.VectorProduct(&TetraederVector[1]);
-  volume = 1./6. * fabs(Point.ScalarProduct(&TetraederVector[2]));
+    TetraederVector[j].SubtractVector(d);
+  Point = TetraederVector[0];
+  Point.VectorProduct(TetraederVector[1]);
+  volume = 1./6. * fabs(Point.ScalarProduct(TetraederVector[2]));
   return volume;
 };
@@ -479,5 +454,5 @@
     for (int j=i+1; j<3; j++) {
       if (nodes[i] == NULL) {
-        Log() << Verbose(1) << "Node nr. " << i << " is not yet present." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Node nr. " << i << " is not yet present." << endl);
         result = true;
       } else if (nodes[i]->lines.find(nodes[j]->node->nr) != nodes[i]->lines.end()) {  // there already is a line
@@ -493,10 +468,10 @@
         }
       } else { // no line
-        Log() << Verbose(1) << "The line between " << *nodes[i] << " and " << *nodes[j] << " is not yet present, hence no need for a degenerate triangle." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "The line between " << *nodes[i] << " and " << *nodes[j] << " is not yet present, hence no need for a degenerate triangle." << endl);
         result = true;
       }
     }
   if ((!result) && (counter > 1)) {
-    Log() << Verbose(1) << "INFO: Degenerate triangle is ok, at least two, here " << counter << ", existing lines are used." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Degenerate triangle is ok, at least two, here " << counter << ", existing lines are used." << endl);
     result = true;
   }
@@ -512,5 +487,5 @@
 //  Vector BaseLineVector, OrthogonalVector, helper;
 //  if (candidate1->BaseLine != candidate2->BaseLine) {  // sanity check
-//    eLog() << Verbose(1) << "sortCandidates was called for two different baselines: " << candidate1->BaseLine << " and " << candidate2->BaseLine << "." << endl;
+//    DoeLog(1) && (eLog()<< Verbose(1) << "sortCandidates was called for two different baselines: " << candidate1->BaseLine << " and " << candidate2->BaseLine << "." << endl);
 //    //return false;
 //    exit(1);
@@ -571,5 +546,5 @@
   for(int i=0;i<NDIM;i++) // store indices of this cell
     N[i] = LC->n[i];
-  Log() << Verbose(1) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl);
 
   LC->GetNeighbourBounds(Nlower, Nupper);
@@ -578,10 +553,9 @@
     for (LC->n[1] = Nlower[1]; LC->n[1] <= Nupper[1]; LC->n[1]++)
       for (LC->n[2] = Nlower[2]; LC->n[2] <= Nupper[2]; LC->n[2]++) {
-        const LinkedNodes *List = LC->GetCurrentCell();
+        const LinkedCell::LinkedNodes *List = LC->GetCurrentCell();
         //Log() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << endl;
         if (List != NULL) {
-          for (LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
-            helper.CopyVector(Point);
-            helper.SubtractVector((*Runner)->node);
+          for (LinkedCell::LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
+            helper = (*Point) - (*(*Runner)->node);
             double currentNorm = helper. Norm();
             if (currentNorm < distance) {
@@ -626,5 +600,5 @@
   for(int i=0;i<NDIM;i++) // store indices of this cell
     N[i] = LC->n[i];
-  Log() << Verbose(1) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl);
 
   LC->GetNeighbourBounds(Nlower, Nupper);
@@ -633,10 +607,9 @@
     for (LC->n[1] = Nlower[1]; LC->n[1] <= Nupper[1]; LC->n[1]++)
       for (LC->n[2] = Nlower[2]; LC->n[2] <= Nupper[2]; LC->n[2]++) {
-        const LinkedNodes *List = LC->GetCurrentCell();
+        const LinkedCell::LinkedNodes *List = LC->GetCurrentCell();
         //Log() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << endl;
         if (List != NULL) {
-          for (LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
-            helper.CopyVector(Point);
-            helper.SubtractVector((*Runner)->node);
+          for (LinkedCell::LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
+            helper = (*Point) - (*(*Runner)->node);
             double currentNorm = helper.NormSquared();
             if (currentNorm < distance) {
@@ -659,8 +632,8 @@
   // output
   if (closestPoint != NULL) {
-    Log() << Verbose(1) << "Closest point is " << *closestPoint;
+    DoLog(1) && (Log() << Verbose(1) << "Closest point is " << *closestPoint);
     if (SecondPoint != NULL)
-      Log() << Verbose(0) << " and second closest is " << *SecondPoint;
-    Log() << Verbose(0) << "." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " and second closest is " << *SecondPoint);
+    DoLog(0) && (Log() << Verbose(0) << "." << endl);
   }
   return closestPoint;
@@ -677,31 +650,24 @@
 	Info FunctionInfo(__func__);
   // construct the plane of the two baselines (i.e. take both their directional vectors)
-  Vector Normal;
-  Vector Baseline, OtherBaseline;
-  Baseline.CopyVector(Base->endpoints[1]->node->node);
-  Baseline.SubtractVector(Base->endpoints[0]->node->node);
-  OtherBaseline.CopyVector(OtherBase->endpoints[1]->node->node);
-  OtherBaseline.SubtractVector(OtherBase->endpoints[0]->node->node);
-  Normal.CopyVector(&Baseline);
-  Normal.VectorProduct(&OtherBaseline);
+  Vector Baseline = (*Base->endpoints[1]->node->node) - (*Base->endpoints[0]->node->node);
+  Vector OtherBaseline = (*OtherBase->endpoints[1]->node->node) - (*OtherBase->endpoints[0]->node->node);
+  Vector Normal = Baseline;
+  Normal.VectorProduct(OtherBaseline);
   Normal.Normalize();
-  Log() << Verbose(1) << "First direction is " << Baseline << ", second direction is " << OtherBaseline << ", normal of intersection plane is " << Normal << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "First direction is " << Baseline << ", second direction is " << OtherBaseline << ", normal of intersection plane is " << Normal << "." << endl);
 
   // project one offset point of OtherBase onto this plane (and add plane offset vector)
-  Vector NewOffset;
-  NewOffset.CopyVector(OtherBase->endpoints[0]->node->node);
-  NewOffset.SubtractVector(Base->endpoints[0]->node->node);
-  NewOffset.ProjectOntoPlane(&Normal);
-  NewOffset.AddVector(Base->endpoints[0]->node->node);
-  Vector NewDirection;
-  NewDirection.CopyVector(&NewOffset);
-  NewDirection.AddVector(&OtherBaseline);
+  Vector NewOffset = (*OtherBase->endpoints[0]->node->node) - (*Base->endpoints[0]->node->node);
+  NewOffset.ProjectOntoPlane(Normal);
+  NewOffset += (*Base->endpoints[0]->node->node);
+  Vector NewDirection = NewOffset + OtherBaseline;
 
   // calculate the intersection between this projected baseline and Base
   Vector *Intersection = new Vector;
-  Intersection->GetIntersectionOfTwoLinesOnPlane(Base->endpoints[0]->node->node, Base->endpoints[1]->node->node, &NewOffset, &NewDirection, &Normal);
-  Normal.CopyVector(Intersection);
-  Normal.SubtractVector(Base->endpoints[0]->node->node);
-  Log() << Verbose(1) << "Found closest point on " << *Base << " at " << *Intersection << ", factor in line is " << fabs(Normal.ScalarProduct(&Baseline)/Baseline.NormSquared()) << "." << endl;
+  *Intersection = GetIntersectionOfTwoLinesOnPlane(*(Base->endpoints[0]->node->node),
+                                                   *(Base->endpoints[1]->node->node),
+                                                     NewOffset, NewDirection);
+  Normal = (*Intersection) - (*Base->endpoints[0]->node->node);
+  DoLog(1) && (Log() << Verbose(1) << "Found closest point on " << *Base << " at " << *Intersection << ", factor in line is " << fabs(Normal.ScalarProduct(Baseline)/Baseline.NormSquared()) << "." << endl);
 
   return Intersection;
@@ -721,5 +687,5 @@
     return -1;
   }
-  distance = x->DistanceToPlane(&triangle->NormalVector, triangle->endpoints[0]->node->node);
+  distance = x->DistanceToPlane(triangle->NormalVector, *triangle->endpoints[0]->node->node);
   return distance;
 };
@@ -747,5 +713,5 @@
       *vrmlfile << "Sphere {" << endl << "  "; // 2 is sphere type
       for (i=0;i<NDIM;i++)
-        *vrmlfile << Walker->node->x[i]-center->x[i] << " ";
+        *vrmlfile << Walker->node->at(i)-center->at(i) << " ";
       *vrmlfile << "\t0.1\t1. 1. 1." << endl; // radius 0.05 and white as colour
       cloud->GoToNext();
@@ -757,5 +723,5 @@
       for (i=0;i<3;i++) { // print each node
         for (int j=0;j<NDIM;j++)  // and for each node all NDIM coordinates
-          *vrmlfile << TriangleRunner->second->endpoints[i]->node->node->x[j]-center->x[j] << " ";
+          *vrmlfile << TriangleRunner->second->endpoints[i]->node->node->at(j)-center->at(j) << " ";
         *vrmlfile << "\t";
       }
@@ -764,5 +730,5 @@
     }
   } else {
-    eLog() << Verbose(1) << "Given vrmlfile is " << vrmlfile << "." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Given vrmlfile is " << vrmlfile << "." << endl);
   }
   delete(center);
@@ -784,13 +750,12 @@
     Vector *center = cloud->GetCenter();
     // make the circumsphere's center absolute again
-    helper.CopyVector(Tess->LastTriangle->endpoints[0]->node->node);
-    helper.AddVector(Tess->LastTriangle->endpoints[1]->node->node);
-    helper.AddVector(Tess->LastTriangle->endpoints[2]->node->node);
-    helper.Scale(1./3.);
-    helper.SubtractVector(center);
+    Vector helper = (1./3.) * ((*Tess->LastTriangle->endpoints[0]->node->node) +
+                               (*Tess->LastTriangle->endpoints[1]->node->node) +
+                               (*Tess->LastTriangle->endpoints[2]->node->node));
+    helper -= (*center);
     // and add to file plus translucency object
     *rasterfile << "# current virtual sphere\n";
     *rasterfile << "8\n  25.0    0.6     -1.0 -1.0 -1.0     0.2        0 0 0 0\n";
-    *rasterfile << "2\n  " << helper.x[0] << " " << helper.x[1] << " " << helper.x[2] << "\t" << 5. << "\t1 0 0\n";
+    *rasterfile << "2\n  " << helper[0] << " " << helper[1] << " " << helper[2] << "\t" << 5. << "\t1 0 0\n";
     *rasterfile << "9\n  terminating special property\n";
     delete(center);
@@ -820,5 +785,5 @@
       *rasterfile << "2" << endl << "  ";  // 2 is sphere type
       for (i=0;i<NDIM;i++)
-        *rasterfile << Walker->node->x[i]-center->x[i] << " ";
+        *rasterfile << Walker->node->at(i)-center->at(i) << " ";
       *rasterfile << "\t0.1\t1. 1. 1." << endl; // radius 0.05 and white as colour
       cloud->GoToNext();
@@ -831,5 +796,5 @@
       for (i=0;i<3;i++) {  // print each node
         for (int j=0;j<NDIM;j++)  // and for each node all NDIM coordinates
-          *rasterfile << TriangleRunner->second->endpoints[i]->node->node->x[j]-center->x[j] << " ";
+          *rasterfile << TriangleRunner->second->endpoints[i]->node->node->at(j)-center->at(j) << " ";
         *rasterfile << "\t";
       }
@@ -839,5 +804,5 @@
     *rasterfile << "9\n#  terminating special property\n";
   } else {
-    eLog() << Verbose(1) << "Given rasterfile is " << rasterfile << "." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Given rasterfile is " << rasterfile << "." << endl);
   }
   IncludeSphereinRaster3D(rasterfile, Tess, cloud);
@@ -862,6 +827,10 @@
     } else {
       *tecplot << N << "-";
-      for (int i=0;i<3;i++)
-        *tecplot << (i==0 ? "" : "_") << TesselStruct->LastTriangle->endpoints[i]->node->Name;
+      if (TesselStruct->LastTriangle != NULL) {
+        for (int i=0;i<3;i++)
+          *tecplot << (i==0 ? "" : "_") << TesselStruct->LastTriangle->endpoints[i]->node->Name;
+      } else {
+        *tecplot << "none";
+      }
     }
     *tecplot << "\", N=" << TesselStruct->PointsOnBoundary.size() << ", E=" << TesselStruct->TrianglesOnBoundary.size() << ", DATAPACKING=POINT, ZONETYPE=FETRIANGLE" << endl;
@@ -877,11 +846,11 @@
       Walker = target->second->node;
       LookupList[Walker->nr] = Counter++;
-      *tecplot << Walker->node->x[0] << " " << Walker->node->x[1] << " " << Walker->node->x[2] << " " << target->second->value << endl;
+      *tecplot << Walker->node->at(0) << " " << Walker->node->at(1) << " " << Walker->node->at(2) << " " << target->second->value << endl;
     }
     *tecplot << endl;
     // print connectivity
-    Log() << Verbose(1) << "The following triangles were created:" << endl;
+    DoLog(1) && (Log() << Verbose(1) << "The following triangles were created:" << endl);
     for (TriangleMap::const_iterator runner = TesselStruct->TrianglesOnBoundary.begin(); runner != TesselStruct->TrianglesOnBoundary.end(); runner++) {
-      Log() << Verbose(1) << " " << runner->second->endpoints[0]->node->Name << "<->" << runner->second->endpoints[1]->node->Name << "<->" << runner->second->endpoints[2]->node->Name << endl;
+      DoLog(1) && (Log() << Verbose(1) << " " << runner->second->endpoints[0]->node->Name << "<->" << runner->second->endpoints[1]->node->Name << "<->" << runner->second->endpoints[2]->node->Name << endl);
       *tecplot << LookupList[runner->second->endpoints[0]->node->nr] << " " << LookupList[runner->second->endpoints[1]->node->nr] << " " << LookupList[runner->second->endpoints[2]->node->nr] << endl;
     }
@@ -904,5 +873,5 @@
   for (PointMap::const_iterator PointRunner = TesselStruct->PointsOnBoundary.begin(); PointRunner != TesselStruct->PointsOnBoundary.end(); PointRunner++) {
     point = PointRunner->second;
-    Log() << Verbose(1) << "INFO: Current point is " << *point << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Current point is " << *point << "." << endl);
     point->value = 0;
     for (LineMap::iterator LineRunner = point->lines.begin(); LineRunner != point->lines.end(); LineRunner++) {
@@ -928,13 +897,13 @@
   int counter = 0;
 
-  Log() << Verbose(1) << "Check: List of Baselines with not two connected triangles:" << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Check: List of Baselines with not two connected triangles:" << endl);
   for (testline = TesselStruct->LinesOnBoundary.begin(); testline != TesselStruct->LinesOnBoundary.end(); testline++) {
     if (testline->second->triangles.size() != 2) {
-      Log() << Verbose(2) << *testline->second << "\t" << testline->second->triangles.size() << endl;
+      DoLog(2) && (Log() << Verbose(2) << *testline->second << "\t" << testline->second->triangles.size() << endl);
       counter++;
     }
   }
   if (counter == 0) {
-    Log() << Verbose(1) << "None." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "None." << endl);
     result = true;
   }
@@ -951,5 +920,5 @@
   // check number of endpoints in *P
   if (P->endpoints.size() != 4) {
-    eLog() << Verbose(1) << "CountTrianglePairContainingPolygon works only on polygons with 4 nodes!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "CountTrianglePairContainingPolygon works only on polygons with 4 nodes!" << endl);
     return 0;
   }
@@ -957,9 +926,9 @@
   // check number of triangles in *T
   if (T->size() < 2) {
-    eLog() << Verbose(1) << "Not enough triangles to have pairs!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Not enough triangles to have pairs!" << endl);
     return 0;
   }
 
-  Log() << Verbose(0) << "Polygon is " << *P << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Polygon is " << *P << endl);
   // create each pair, get the endpoints and check whether *P is contained.
   int counter = 0;
